<?php
namespace Folha\Repositories;

use \Setforms2\Shared\Connection;

class FpaResumoctbl extends \Doctrine\ORM\EntityRepository
{

    /**
     *
     * @param int $nrestruturam
     * @param int $nrorg
     * @return int[]
     */
    public static function getCodIntEmpresa($nrestruturam, $nrtipoestrutura, $nrorg)
    {
        $sql = <<<SQL
SELECT NRESTRUTURAM,
    LPAD(CDINTESTRUTURA, 2, '0') AS CDINTESTRUTURA
FROM ESTRUTURAM
WHERE NRORG = :P_NRORG
    AND NRESTRUTURAM IN  (SELECT DISTINCT DECODE(TIPOHIERARQORG.NRTIPOESTRUTREL,1,HIERARQUIAORG.NRESTRUTURAMREL, HIERARQUIAORG.NRESTRUTURAMSUP) NRESMPRESA
                          FROM HIERARQUIAORG
                          INNER JOIN TIPOHIERARQORG
                              ON TIPOHIERARQORG.NRTIPOHIERARQORG = HIERARQUIAORG.NRTIPOHIERARQORG
                              AND (TIPOHIERARQORG.NRORG = HIERARQUIAORG.NRORG OR TIPOHIERARQORG.NRORG = :P_NRORG_PADRAO)
                          WHERE HIERARQUIAORG.NRORG = :P_NRORG
                              AND (TIPOHIERARQORG.NRTIPOESTRUTSUP = :P_NRTIPOESTRUTURA
                                  OR TIPOHIERARQORG.NRTIPOESTRUTREL = :P_NRTIPOESTRUTURA)
                              AND (HIERARQUIAORG.NRESTRUTURAMREL = :P_NRESTRUTURAM
                                  OR HIERARQUIAORG.NRESTRUTURAMSUP = :P_NRESTRUTURAM))
SQL;
        $params = array(
            'P_NRORG' => $nrorg,
            'P_NRESTRUTURAM' => $nrestruturam,
            'P_NRORG_PADRAO' => 0,
            'P_NRTIPOESTRUTURA' => $nrtipoestrutura
        );

        $resultado = Connection::getInstance()->fetchAll($sql, $params);
        return $resultado[0]['CDINTESTRUTURA'];

    }
}