/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GROPERLESTOQ                                              */
/* Tabela : GROPERLESTOQ                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 28/10/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GROPERLESTOQ' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GROPERLESTOQ
GO

CREATE TRIGGER DTULTATU_GROPERLESTOQ
ON GROPERLESTOQ
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GROPERLESTOQ', CDFILIAL, 'CDFILIAL='+ CDFILIAL+ ';'+
                                      'CDGRUPOPER='+ CDGRUPOPER+ ';' +'CDALMOXARIFE='+ CDALMOXARIFE+ ';'+
                                      'CDLOCALESTOQ='+ CDLOCALESTOQ +';',
                                      GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GROPERLESTOQ
      SET DTULTATUGRLE = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(GROPERLESTOQ.CDGRUPOPER,0)   = ISNULL(INSERTED.CDGRUPOPER,0)) AND
            (ISNULL(GROPERLESTOQ.CDLOCALESTOQ,0) = ISNULL(INSERTED.CDLOCALESTOQ,0)) AND
            (ISNULL(GROPERLESTOQ.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(GROPERLESTOQ.CDALMOXARIFE,0) = ISNULL(INSERTED.CDALMOXARIFE,0));
   END;
END;
GO

